/*
KindHud: the mod
By Jaden (the entirety of this with my lua knowledge)

- 1st file: Init

- Note: This mod is a mess.
*/

rawset(_G, "kind", {}) -- do the mario

rawset(_G, "GetCountdownLogic", function(v, timer)
	local function DrawRaceNum(time)
		local bounce, racenum
		local y = 142
		local racenumstr = ""

		time = $ + TICRATE
		bounce = TICRATE - (1 + (time % TICRATE))

		if (time/TICRATE == 3) then racenum = v.cachePatch("RACE3")
		elseif (time/TICRATE == 2) then racenum = v.cachePatch("RACE2")
		elseif (time/TICRATE == 1) then racenum = v.cachePatch("RACE1")
		else
			racenum = v.cachePatch("RACEGO")
			racenumstr = "RACEGO"
		end

		if (bounce < 3) then
			y = $ - (2 - bounce)
			if (not (paused) and not bounce) then
				S_StartSound(nil, ((racenumstr == "RACEGO") and sfx_s3kad or sfx_s3ka7))
			end
		end

		local x = ((320 - racenum.width)/2)
		v.draw(x, y, racenum, 0)
	end
	
	local tics, timelimitintics, downwards
	local countdowntimer = mapheaderinfo[gamemap].countdown * TICRATE
	
	local cv_hidetime = CV_FindVar("hidetime")
	
	-- start drawing the time!
	
	if (timelimit > 0) then timelimitintics = timelimit * (60 * TICRATE) end

	// Counting down the hidetime?
	if ((gametyperules & GTR_STARTCOUNTDOWN) and (cv_hidetime and cv_hidetime.value) and (timer <= (cv_hidetime.value*TICRATE))) then
		tics = (cv_hidetime.value*TICRATE - timer)
		
		if (tics < 3*TICRATE) then
			DrawRaceNum(tics)
		end
		
		tics = $ + (TICRATE-1) -- match the race num
		downwards = true
	else
		-- Hidetime finish!
		if ((gametyperules & GTR_STARTCOUNTDOWN) and (timer < (cv_hidetime.value+1)*TICRATE)) then
			DrawRaceNum(cv_hidetime.value*TICRATE - timer)
		end

		-- Time limit?
		if ((gametyperules & GTR_TIMELIMIT) and timelimit) then
			if (timelimitintics > timer) then
				tics = (timelimitintics - timer)
				
				if (tics < 3*TICRATE) then
					DrawRaceNum(tics)
				end
				
				tics = $ + (TICRATE-1) -- match the race num
			else -- Overtime!
				tics = 0
			end
			downwards = true
		
		-- Post-hidetime Normal.
		elseif (gametyperules & GTR_STARTCOUNTDOWN)
			tics = timer - hidetime*TICRATE
			
		-- * insert large source code comment here *
		elseif (mapheaderinfo[gamemap].countdown) then
			tics = countdowntimer
			downwards = true
		else
			tics = timer
			downwards = false
		end
	end
	
	return tics, downwards
end)

rawset(_G, "DrawCustomNum", function(v, x, y, num, font, flags, align)
	local start, finish
	local right = (align < 0)
	
	flags = $ or 0
	align = $ or 1
	
	num = tostring(num)

	if right then
		start = num:len()
		finish = 1
	else
		start = 1
		finish = num:len()
	end

	for i = start, finish, align do
		local letter = font .. num:sub(i, i)
		
		if not v.patchExists(letter) then continue end

		local patch = v.cachePatch(letter)

		if right then -- right aligned, change offset before drawing
			x = $ - patch.width
		end

		v.draw(x, y, patch, flags)

		if not right then -- left aligned, change offset after drawing
			x = $ + patch.width
		end
	end
end)

// im tired of the V_&COLOR things
kind.ColorToString = function(color)
	if not (color > 0) then
		return "\x80"
	end
	local textcolor = (skincolors[color].chatcolor - V_MAGENTAMAP) >> 12
	
	return (skincolors[color].chatcolor ~= 0) and string.char(textcolor + 129) or "\x80"
end

kind.enabled = CV_RegisterVar({
	name = "kind_enabled",
	defaultvalue = "On",
	flags = CV_MODIFIED,
	PossibleValue = CV_OnOff
})

kind.style = CV_RegisterVar({
	name = "kind_style",
	defaultvalue = "Minimal",
	flags = CV_MODIFIED,
	PossibleValue = {Minimal = 0, Blasted = 1}
})

kind.speedometer = CV_RegisterVar({
	name = "kind_speedometer",
	defaultvalue = "On",
	flags = CV_MODIFIED,
	PossibleValue = CV_OnOff
})

kind.speedstyle = CV_RegisterVar({
	name = "kind_speedstyle",
	defaultvalue = "Fracunits",
	flags = CV_MODIFIED,
	PossibleValue = {Fracunits = 0, Miles = 1, Kilometers = 2}
})

kind.LivesBlacklist = {
	["kiryu"] = true
}

// um..
skincolors[freeslot("SKINCOLOR_THECOMPLETELYBLACKCOLOR")] = {
	name = "Extreme Black",
	ramp = {31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31},
	accessible = false
}